import java.awt.*;
import javax.swing.*;

/**
 * <b>Programm:</b> Wave<br>
 * <b>Copyright:</b> 2002 Andreas Gohr, Frank Schubert<br>
 * <b>License:</b> GPL2 or higher<br>
 * <br>
 * <b>Info:</b> This JPanel uses a GridbagLayout to layout the components and
 * gives a convinient method to add components
 */
class ManagedPanel extends JPanel{
  GridBagLayout gbl;

  /**
   * Constructor
   */
  public ManagedPanel(){
    gbl = new GridBagLayout();
    setLayout(gbl);
  }

  /**
   * adds a component to the Layout at specified position
   */
  public void addComponent(Component c,
                           int row, int col, 
                           int rowspan, int colspan, 
                           double rowweight, double colweight ){

    GridBagConstraints gbc = new GridBagConstraints();
    gbc.fill = gbc.BOTH;
    gbc.gridx = row;
    gbc.gridy = col;
    gbc.gridwidth = rowspan;
    gbc.gridheight = colspan;
    gbc.weightx = rowweight;
    gbc.weighty = colweight;
    
    add(c);
    gbl.setConstraints(c, gbc);
  }
}
