import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.event.*;

/**
 * <b>Programm:</b> Wave<br>
 * <b>Copyright:</b> 2002 Andreas Gohr, Frank Schubert<br>
 * <b>License:</b> GPL2 or higher<br>
 * <br>
 * <b>Info:</b> Main class, implements all needed listeners
 */
public class WaveMain extends JPanel
                      implements ChangeListener{
  Painting _p = null;
  InputPanel _ip = null;
  Wave2D _wave = null;
  
  /**
   * Constructor
   */
  public WaveMain(){
    _wave = new Wave2D(100.0,30,0.0);
    _p = new Painting(_wave);
    _ip = new InputPanel(this);

    
    setLayout(new BorderLayout());
    add(_p, BorderLayout.CENTER);
    add(_ip, BorderLayout.EAST);
  }
  
  /**
   *changelistener for sliders
   */
  public void stateChanged(ChangeEvent e){
    JSlider slider = (JSlider) e.getSource();
    
    if (slider.getName() == "lambda"){
      _wave.setWaveLength(slider.getValue()/100.0);
    }else if(slider.getName() == "A"){
       _wave.setAmplitude(slider.getValue());
    }else if(slider.getName() == "phi"){
       _wave.setPhase(slider.getValue()/100.0);
    }else if(slider.getName() == "zoom"){
       _p.setZoom(slider.getValue()/100.0);
    }else{
       System.err.println("Huh? Got non existant slider?: "+
	                  slider.getName()+" "+slider.getValue());
    }
    _p.repaint();
  }
}

